import 'package:flutter/foundation.dart';
import 'package:flutter_riverpod/flutter_riverpod.dart';
import 'package:flutter_test/flutter_test.dart';

import 'utils.dart';

final incrementProvider = ChangeNotifierProvider<IncrementNotifier>(
  (ref) => IncrementNotifier(13), // <1>
);

class IncrementNotifier extends ChangeNotifier {
  IncrementNotifier(this.number);

  int number;

  void increment() {
    number++;
    notifyListeners();
  }
}

void main() {
  test('doit incrémenter un état', () {
    // given:
    final container = createContainer();

    // expect:
    expect(container.read(incrementProvider.notifier).number, equals(13)); // <2>

    // when:
    container.read(incrementProvider).increment(); // <3>

    // then:
    expect(container.read(incrementProvider).number, equals(14)); // <4>
  });
}
