import 'package:flutter_riverpod/flutter_riverpod.dart';
import 'package:flutter_test/flutter_test.dart';

import 'utils.dart';

final Matcher throwsProviderException = throwsA(const TypeMatcher<ProviderException>());

final Provider<int> provider = Provider<int>((ref) => ref.watch(otherProvider)); // <1>
final Provider<int> otherProvider = Provider<int>((ref) => ref.watch(provider));

void main() {
  test('doit lever une exception suite à une dépendance circulaire', () {
    // given:
    final container = createContainer();

    // expect:
    expect(() => container.read(provider), throwsProviderException); // <2>
  });
}
