import 'package:flutter_riverpod/flutter_riverpod.dart';
import 'package:flutter_test/flutter_test.dart';

import 'utils.dart';

final intProvider = Provider<int>((_) => 13); // <1>
final otherIntProvider = Provider<int>((_) => 13);

void main() {
  test('doit surcharger le comportement des Provider', () {
    // given:
    final container = createContainer(
      overrides: [
        intProvider.overrideWithProvider(Provider<int>((_) => 42)), // <2>
        otherIntProvider.overrideWithValue(42),
      ],
    );

    // expect:
    expect(container.read(intProvider), 42); // <3>
    expect(container.read(otherIntProvider), 42);
  });
}
