import 'package:flutter_riverpod/flutter_riverpod.dart';
import 'package:flutter_test/flutter_test.dart';

import 'utils.dart';

final intProvider = StateProvider((_) => 13); // <1>
final moduloProvider = Provider<int>((ref) => ref.watch(intProvider.select((state) => state % 10)));

void main() {
  test('doit écouter le modulo 10', () {
    // given:
    final container = createContainer();

    // and:
    var called = 0;
    container.listen(moduloProvider, (_, __) => called++); // <2>

    // expect:
    expect(container.read(moduloProvider), equals(3)); // <3>
    expect(called, equals(0));

    // when:
    container.read(intProvider.notifier).state = 42; // <4>

    // then:
    expect(container.read(moduloProvider), equals(2)); // <5>
    expect(called, equals(1));

    // when:
    container.read(intProvider.notifier).state = 22; // <6>

    // expect:
    expect(container.read(moduloProvider), equals(2)); // <7>
    expect(called, equals(1));
  });
}
